博客
关于我
强烈建议你试试无所不能的chatGPT,快点击我
Codeforces 712C Memory and De-Evolution
阅读量:6295 次
发布时间:2019-06-22

本文共 2594 字,大约阅读时间需要 8 分钟。

C. Memory and De-Evolution
time limit per test:2 seconds
memory limit per test:256 megabytes
input:standard input
output:standard output

Memory is now interested in the de-evolution of objects, specifically triangles. He starts with an equilateral triangle of side length x, and he wishes to perform operations to obtain an equilateral triangle of side length y.

In a single second, he can modify the length of a single side of the current triangle such that it remains a non-degenerate triangle (triangle of positive area). At any moment of time, the length of each side should be integer.

What is the minimum number of seconds required for Memory to obtain the equilateral triangle of side length y?

Input

The first and only line contains two integers x and y (3 ≤ y < x ≤ 100 000) — the starting and ending equilateral triangle side lengths respectively.

Output

Print a single integer — the minimum number of seconds required for Memory to obtain the equilateral triangle of side length y if he starts with the equilateral triangle of side length x.

Examples
Input
6 3
Output
4
Input
8 5
Output
3
Input
22 4
Output
6
Note

In the first sample test, Memory starts with an equilateral triangle of side length 6 and wants one of side length 3. Denote a triangle with sides a, b, and c as (a, b, c). Then, Memory can do .

In the second sample test, Memory can do .

In the third sample test, Memory can do:

.

解题思路:

【题意】

现有边长为x的等边三角形,Memory想要将其变成边长为y的等边三角形

现规定Memory每秒能够改变一条边的大小,但要保证改变后的三条边仍能构成一个三角形

问,最少需要多少时间才能变为边长为y的等边三角形

【类型】

贪心,逆推

【分析】

从边长为6的等边三角形变为边长为3的等边三角形。先将一边变为3,则(6,6,3),如果再将一边变成3,则(6,3,3)并不能组成三角形,所以只能先变为(6,4,3)然后变为(3,4,3),最后变为(3,3,3),一共4步,所以输出4,此题很明显是贪心,直接贪就是了,用一个数记录需要的时间即可!此题需要注意的是最好选择逆推法,由y->x,这样就能保证合法且最快了!

 

【时间复杂度&&优化】

O(n)

 

题目链接→

1 #include 
2 using namespace std; 3 int main() 4 { 5 int s[3]; 6 int x,y,i; 7 while(cin>>x>>y) 8 { 9 int ans=0;10 s[0]=s[1]=s[2]=y;11 for(i=0;s[0]

 

 经过学长的提醒,我想出了另外一种方法,这样更简单!

1 #include 
2 using namespace std; 3 int main() 4 { 5 int s[3]; 6 int x,y,i; 7 while(cin>>x>>y) 8 { 9 s[0]=s[1]=s[2]=y;10 for(i=0;s[0]

这样写也可以!

1 #include 
2 using namespace std; 3 int main() 4 { 5 int s[3]; 6 int x,y,i; 7 while(cin>>x>>y) 8 { 9 s[0]=s[1]=s[2]=y;10 int ans=0;11 while(s[0]!=x||s[1]!=x||s[2]!=x)12 {13 sort(s,s+3);14 s[0]=min(s[1]+s[2]-1,x);15 ans++;16 }17 cout<
<

 

 

转载地址:http://eapta.baihongyu.com/

你可能感兴趣的文章
弗洛伊德算法
查看>>
【算法之美】求解两个有序数组的中位数 — leetcode 4. Median of Two Sorted Arrays
查看>>
精度 Precision
查看>>
Android——4.2 - 3G移植之路之 APN (五)
查看>>
Linux_DHCP服务搭建
查看>>
[SilverLight]DataGrid实现批量输入(like Excel)(补充)
查看>>
秋式广告杀手:广告拦截原理与杀手组织
查看>>
翻译 | 摆脱浏览器限制的JavaScript
查看>>
闲扯下午引爆乌云社区“盗窃”乌云币事件
查看>>
02@在类的头文件中尽量少引入其他头文件
查看>>
JAVA IO BIO NIO AIO
查看>>
input checkbox 复选框大小修改
查看>>
BOOT.INI文件参数
查看>>
vmstat详解
查看>>
新年第一镖
查看>>
unbtu使用笔记
查看>>
OEA 中 WPF 树型表格虚拟化设计方案
查看>>
Android程序开发初级教程(一) 开始 Hello Android
查看>>
使用Gradle打RPM包
查看>>
“我意识到”的意义
查看>>